<?php

require_once('plugins/webtools/webtools/functions.php');

$rcmail = rcmail::get_instance();
$HOME = $rcmail->config->get('HOME');
$USERNAME = $rcmail->config->get('USERNAME');
$RUNAS_CMD = $rcmail->config->get('RUNAS_CMD');
$MF = $rcmail->config->get('MF');
$STF = $rcmail->config->get('STF');
$USERINFO = $rcmail->config->get('USERINFO');

?>

<h2>Hush Quota</h2>

<?php

$result = NULL;
$hush_enabled = have_file("Maildir/RU-HUSH-QUOTA", $result);

$button = '';
$text = '';

if ($hush_enabled) {
    $button = '<button class="webtools-button ui-state-default ui-corner-all" type="button" onclick="hushquota_post(true); return false;">Disable</button>';
    $text = 'You currently have "hush" enabled. Click "Disable" to START receiving such messages again.';
}
else {
    $button = '<button class="webtools-button ui-state-default ui-corner-all" type="button" onclick="hushquota_post(); return false;">Enable</button>';
    $text = 'Click "Enable" to STOP receiving such messages.';
}

?>

<script type="text/javascript" src="plugins/webtools/webtools/hushquota/hushquota_post.js"></script>

<div id="result"></div>

<div id="webtools-innerbox" class="ui-widget ui-widget-content ui-corner-all">
    <div>
        Use this tool to control whether or not this account receives messages
        warning that it is near or at its quota limit.
    </div>
    <div id="text" style="margin-top: 1em; color: #BD0E2E;">
        <?=$text?>
    </div>
    <form style="margin: 20px 0;">
        <div id="button">
            <?=$button?>
        </div>
    </form>
</div>

<div id="webtools-instructions" class="webtools-accordion">
    <div>
        <h3><a id="instr-header" href="#">Help</a></h3>
        <div id="instr-content">
            The "hush" feature is disabled by default.  That is, if you take no action,
            you will receive an e-mail warning when you are approaching your account's
            quota. Use this tool only if you want to stop such messages ("hush" them).
            <br /><br />
            The quota warnings are special messages which cannot be forwarded to
            another account.  Even if you forward all your other mail off of this
            account, you will only see these messages if you look at this account's
            Inbox.
        </div>
    </div>
</div>
