<?php

function vacation_post_handler() {

    $rcmail = rcmail::get_instance();

    $USERNAME = $rcmail->config->get('USERNAME');
    $HOME = $rcmail->config->get('HOME');
    $RUNAS_CMD = $rcmail->config->get('RUNAS_CMD');
    $MF = $rcmail->config->get('MF');

    $subject = getvar('subject');
    $message = getvar('message');
    
    $forwardType = getvar('forwardType');
    $oldFormatAddr_S = getvar('oldFormatAddr_S');

    $newFormatAddr_S = getvar('newFormatAddr_S');
    $newForwardFileExist = getvar('newForwardFileExist');
    $newVacationFileExist = getvar('newVacationFileExist');

    $localCopy = getvar('localCopy');
    
    // Is the user disabling forwarding?
    $disable = getvar('disable');

    // Initialize other variables
    $insert = '';
    $createForward = true;
    $allAddr_Arr = array();
    $newFormatAddr_Arr = NULL;
    $type = '';
    $msg = '';
    $user_cmd = '';
    $success = true;

    // This is the response that will be sent back to the client
    $response = array('message' => '', 'new_content' => '', 'new_vacmsg' => '', 'update_content' => 'yes');

    if (!$disable) {
        if (isset($message)) {
            $message = stripslashes($message);
        }
        if (empty($subject)) {
            $subject = "Away on vacation";
        }
    }

    // Set insert to display some rutgers specific comments
    $insert = "################################################\n";
    $insert .= "# THIS FILE WAS CREATED BY A WEBTOOL.          #\n";
    $insert .= "# DO NOT EDIT THIS FILE BY HAND.               #\n";
    $insert .= "################################################\n\n";

    
    if (!$disable) {
        $insert .= getVacationRule($subject, NULL)."\n";
    }

    // Are we converting from old-format forward file?
    if (isset($forwardType)) {
        if(isset($oldFormatAddr_S)) {
            $oldFormatAddr_Arr = unserialize(base64_decode($oldFormatAddr_S));
            $allAddr_Arr = array_merge($oldFormatAddr_Arr, $allAddr_Arr);
        }
    }

    // Are we adding on top of new-format forward file?
    if ($newFormatAddr_S) {
        $newFormatAddr_Arr = unserialize(base64_decode($newFormatAddr_S));
        $allAddr_Arr = array_merge($newFormatAddr_Arr, $allAddr_Arr);
    }

    if ($disable && empty($allAddr_Arr)) { 
        $createForward = false;
    }

    // Are we leaving a local copy?
    if (isset($localCopy) && ($localCopy == 0)) {
        if (!empty($allAddr_Arr)) {
            $addresses = implode(' ', $allAddr_Arr);
            $insert .= 'to "!'.$addresses.'"';
        }
    }
    else {
        if (!empty($allAddr_Arr)) {
            $addresses = implode(' ', $allAddr_Arr);
            $insert .= 'cc "!'.$addresses.'"';
        }
    }

    // Should we write the new forward file?
    if ($createForward) {
        $user_cmd = "$MF Maildir/mailfilter-forward";
        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
        unipipe_exec($exec_target, $insert, $status);
        if ($status != 0) {
            $msg .= 'Could not create your new forward/vacation file.<br />';
            $success = false;
        }
        elseif (!$disable) {
            $msg .= 'Your new forward/vacation file was created.<br />';
        }
        else {
            $msg .= 'Vacation auto-response has been successfully disabled.<br />';
        }
    }
    elseif ($success && $disable) {
        // No forward rules, so just remove the file
        $user_cmd = "find $HOME -maxdepth 2 -path $HOME/Maildir/mailfilter-forward -exec rm -f '{}' \;";
        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
        exec($exec_target, $result, $status);
        if ($status != 0) {
            $msg .= 'Tried removing your forward/vacation file, but failed.<br />';
            $success = FALSE;
        }
        else {
            $msg .= 'Removed your forward/vacation file.<br />';
        }
    }

    if ($success && !$disable) {
        // Write the vacation message file
        $user_cmd = "$MF .vacation.msg";
        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
        unipipe_exec($exec_target, $message, $status);
        if ($status != 0) {
            $msg .= 'Tried creating your vacation message file, but failed.<br />';
            $success = FALSE;
        }
    }

    // Move (or remove if disabling) the old-format vacation file if it exists
    if ($success && $newVacationFileExist) {
        if (!$disable) {
            $user_cmd = "find $HOME -maxdepth 2 -path $HOME/Maildir/mailfilter-vacation -exec mv '{}' $HOME/Maildir/mailfilter-vacation-old \;";
        }
        else {
            $user_cmd = "find $HOME -maxdepth 2 -path $HOME/Maildir/mailfilter-vacation -exec rm -f '{}' \;";
        }
        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
        exec($exec_target, $result, $status);
        if ($status != 0) {
            if (!$disable) { 
                $msg .= 'Could not move your old mailfilter-vacation file to mailfilter-vacation-old<br />';
            }
            else {
                $msg .= 'Could not remove your old mailfilter-vacation file<br />';
            }
            $success = false;
        }
        else {
            if (!$disable) {
                $msg .= 'Moved your old mailfilter-vacation file to mailfilter-vacation-old<br />';
            }
            else {
                $msg .= 'Removed your old mailfilter-vacation file<br />';
            }
        }
    }
        
    // Move the old-format forward file if it exists
    if ($success && $forwardType) {
        switch($forwardType) {
            case 'f':
                $user_cmd = "find $HOME -maxdepth 1 -name .forward -exec mv '{}' $HOME/.forward-old-webtool \;";
                $type = '.forward';
                break;
            case 'q':
                    $user_cmd = "find $HOME -maxdepth 1 -name .qmail -exec mv '{}' $HOME/.qmail-old-webtool \;";
                    $type = '.qmail';
                    break;
        }

        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
        exec($exec_target, $result, $status);

        if ($status != 0) {
            $msg .= "Could not move your old $type file to $type-old-webtool.<br />";
            $success = false;
        }
        else {
            $msg .= "Your old $type file has been moved to $type-old-webtool.<br />";
        }
    }

    // Remove the autoresponse stuff whenever the user makes it this far
    $file_Arr[0] = 'autoresponsedb.gdbm';
    $file_Arr[1] = 'autoresponsedb.lock';
    foreach($file_Arr as $file) {
        $user_cmd = "find $HOME -maxdepth 1 -name $file -exec rm -f '{}' \;";
        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
        exec($exec_target, $result, $status);
    }

    if ($success) {
        if (!$disable) {
            $response['new_content'] = 'You currently have vacation auto-response enabled. <a href="#" onclick="vacation_post(true); return false;">Disable vacation</a><br /><br />';
        }
        $response['message'] = '<div id="webtools-response" class="ui-state-highlight ui-corner-all">Thank you '.$USERNAME.',<br /><br />'.$msg;
        $response['new_vacmsg'] = 'You have the option to keep the message you already have (provided below) or edit it:';   
    }
    else {
        $response['message'] = '<div id="webtools-response" class="ui-state-error ui-corner-all">Sorry '.$USERNAME.',<br /><br />'.$msg;
        $response['update_content'] = 'no';
    }
    $response['message'] .= '</div>';

    $rcmail->output->command('plugin.vacation-post-callback', $response);
}

?>
